// dollarcent.h  UNFINISHED
// Glenn G. Chappell
// 3 Oct 2013
//
// For CS 202 Fall 2013
// Header for class DollarCent
// Holds an amount of money in dollars & cents

#ifndef FILE_DOLLARCENT_INCLUDED_H
#define FILE_DOLLARCENT_INCLUDED_H


// class DollarCent
// Keeps track of an amount of money, in dollars & cents.
//
// The money amount may be positive, negative, or zero. In the external
// interface of the class, dollars and cents are dealt with separately.
// A number of cents returned by a function in the package always lies
// in the interval [0,99] if the amount of money is nonnegative, and in
// the interval [-99,0] if the amount of money is negative.
//
// If a number of cents specified by a calling function lies outside
// these intervals, then the number of dollars is adjusted accordingly.
// For example, constructing a DollarCent object, specifying -10 dollars
// and 170 cents will result in an object representing a value of
// $-8.30. Returned dollar and cent values will be -8 and -30,
// respectively.
class DollarCent {

// ***** DollarCent: ctors, dctor *****
public:

    // Ctor: default, one int, two ints
    // Constructs an object representing the given number of
    // dollars and cents (see above for details).
    DollarCent(int dollars=0, int cents=0)
    {
        setDC(dollars, cents);
    }

    // Compiler-generated dctor used

// ***** DollarCent: general public functions *****
public:

    // getDC, setDC
    // Get- and set-functions for both dollars and cents at the
    // same time. getDC returns values in reference parameters.
    // See above for details of values.
    void getDC(int & dollars, int & cents) const
    {
        dollars = _dollars;
        cents = _cents;
    }
    void setDC(int dollars, int cents)
    {
        int totalcents = 100*dollars + cents;
        _dollars = totalcents / 100;
        _cents = totalcents % 100;
    }

// ***** DollarCent: data members *****
private:

    // Our amount in dollars & cents (see above).
    int _dollars;
    int _cents;

};  // End class DollarCent


#endif //#ifndef FILE_DOLLARCENT_INCLUDED_H

